float DigFil(invar, setic)
float invar; int setic;
/******************************************************************************/
/* Filter Solutions Version 2020                 Nuhertz Technologies, L.L.C. */
/*                                                            www.nuhertz.com */
/*                                                            +1 602-279-2448 */
/* 10th Order Band Pass Butterworth                                           */
/* Bilinear Transformation with Prewarping                                    */
/* Sample Frequency = 1.000 KHz                                               */
/* Standard Form                                                              */
/* Arithmetic Precision = 4 Digits                                            */
/*                                                                            */
/* Center Frequency = 187.0 Hz                                                */
/* Pass Band Width = 5.000 Hz                                                 */
/* Pass Band Attenuation = 1 dB                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Input Variable Definitions:                                                */
/* Inputs:                                                                    */
/*   invar    float       The input to the filter                             */
/*   setic    int         1 to initialize the filter to zero                  */
/*                                                                            */
/* Option Selections:                                                         */
/* Standard C;   Initializable;            Internal States;   Optimized;      */
/*                                                                            */
/* There is no requirement to ever initialize the filter.                     */
/* The default initialization is zero when the filter is first called         */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* This software is automatically generated by Filter Solutions               */
/* no restrictions from Nuhertz Technologies, L.L.C. regarding the use and    */
/* distributions of this software.                                            */
/*                                                                            */
/******************************************************************************/

{
    float sumnum=0.0, sumden=0.0;  int i=0;
    static float states[20] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
    static float znum[11] = {
        1.616e-18,
        0.0,
        -1.616e-17,
        0.0,
        7.272e-17,
        0.0,
        -1.939e-16,
        0.0,
        3.394e-16,
        0.0,
        -4.073e-16
    };
    static float zden[20] = {
        0.8066,
        -6.287,
        30.29,
        -103.6,
        280.6,
        -622.5,
        1169.0,
        -1883.0,
        2640.0,
        -3237.0,
        3489.0,
        -3307.0,
        2756.0,
        -2009.0,
        1274.0,
        -693.1,
        319.3,
        -120.5,
        35.98,
        -7.629
    };
    if (setic==1){
        for (i=0;i<20;i++) states[i] = 0.1418*invar;
        return 0.0;
    }
    else{
        sumnum = sumden = 0.0;
        for (i=0;i<20;i++){
            sumden += states[i]*zden[i];
            sumnum += states[i]*znum[i<11?i:20-i];
            if (i<19) states[i] = states[i+1];
        }
        states[19] = invar-sumden;
        sumnum += states[19]*znum[0];
        return sumnum;
    }
}
